<?
include_once('sonos.ips.zonecfg.inc');
include_once('sonos.ips.config.inc');
include_once('sonos.ips.translations.php');
if(!function_exists('Debug')){function Debug($data){IPS_LogMessage('SONOS_LOG:',$data);}}

function IPSSonos_SetValue($varId, $value, $varIdent=''){
	if(!$varIdent){
		if(!$obj=@IPS_GetObject($varId))return false;
		$varIdent=$obj['ObjectIdent'];
	}
	$v=IPSSonos_TranslateValue($varIdent,$value);

	if(is_array($v)){
		$parentId=IPS_GetParent($varId);
		foreach($v as $varIdent=>$value){
			$id=@IPS_GetObjectIdByIdent($varIdent,$parentId);
			if($id && (GetValue($id)!=$value))SetValue($id,$value);
		}
	}else if(GetValue($varId)!=$v)SetValue($varId,$v);
		
}

function IPSSonos_RegisterEvents($PlayerId){
	include('sonos.ips.class.php');
	(new IPSSonosPlayer($PlayerId))->RegisterEvents();
}

function IPSSonos_UnRegisterEvents($PlayerId){
	include('sonos.ips.class.php');
	(new IPSSonosPlayer($PlayerId))->UnRegisterEvents();
}

function IPSSonos_UpdateZoneInfos(){
	Debug( "IPSSonos_UpdateZoneInfos");

	$MasterPlayerHost=GetValue(VAR_MasterDeviceId);
	if(!$MasterPlayerHost){
		Debug( "SONOS_INSTALL: Discover Player => Please enter a adress for ".SONOS_name_cfgmaster." and try again");
		return;
	}	
	$ZonePlayers=(new IPSSonosPlayer($MasterPlayerHost))->getZonePlayerList();
	$Show_Players=$Show_Zones=$Show_Instances=null;
	
	$Ids = IPS_GetChildrenIDs(VAR_PlayerCategoryId);
	foreach($Ids as $id)$Show_Players[$id]=false;
	$Ids = IPS_GetChildrenIDs(VAR_WebFrontZonesCatId);
	foreach($Ids as $id)$Show_Zones[$id]=false;
	$Ids = IPS_GetChildrenIDs(VAR_WebFrontZonePlayersInstanceId);
	foreach($Ids as $id)$Show_Instances[$id]=false;
//	@IPS_SetVariableCustomProfile(VAR_WebFrontZoneSelectorVarId,'');
	@IPS_DeleteVariableProfile(VAR_ProfilZones);
	@IPS_CreateVariableProfile(VAR_ProfilZones,1);
	
	$zoneCount=0; $playerCount=0; 
	$ZoneInfo=$PlayerInfo=[]; 
	foreach($ZonePlayers as $zone=>$players) {
		$dupecheck=[]; 	$zonePlayerLink=0;
		if(substr($zone,0,7)=='RINCON_')$zone=substr($zone,7);
		$ZoneId=@IPS_GetObjectIDByIdent($zone,VAR_WebFrontZonesCatId);
		if(!$ZoneId){
			$ZoneId=IPSSonos_CreateCategory($zone,VAR_WebFrontZonesCatId,0);
		}
		$Show_Zones[$ZoneId]=true;
		$ZoneInfo[$zoneCount]['ZoneId']=$ZoneId;
		$ZoneInfo[$zoneCount]['MasterPlayer']=0;
		$ZoneInfo[$zoneCount]['Zone']=$zone;
		foreach($players as $playerNr=>$player){
			$name=$player['name'];
			$ident=$player['ident'];
			$master=(bool)($playerNr==0);
			$PlayerId = IPSSonos_CreatePlayer($player,  $playerNr);
//echo "Player : $PlayerId\n";
			$Show_Players[$PlayerId]=true;
			if($master)$ZoneInfo[$zoneCount]['MasterPlayer']=$PlayerId;
			$PlayerInfo[$playerCount]['ObjectId']=$PlayerId;
			$PlayerInfo[$playerCount]['ZoneNr']=$zoneCount;
			$PlayerInfo[$playerCount]['ZoneId']=$ZoneId;
			$PlayerInfo[$playerCount]['Ident']=$ident;
			$PlayerInfo[$playerCount]['Master']=($master)?'true':'false';
			
			if(in_array($name,$dupecheck)===false){
				$tmp=@CreateVariable ('PL_'.$ident,0,VAR_WebFrontZonePlayersInstanceId,0,VAR_ProfilPlayAddZonePlayer,VAR_ActionScriptId,false,'');
				IPS_SetName($tmp,$name);
				$Show_Instances[$tmp]=true;
				$dupecheck[]=$name;
				$link=@IPSSonos_CreateLink ($ident, $PlayerId, $ZoneId, $playerNr, $ident);
				IPS_SetHidden($link,!$master);
				if($master)$zonePlayerLink=$link;else IPS_SetName($link,$name);
			}
			$playerCount++;
		}
		$zoneName=implode(',',$dupecheck);
		@IPS_SetVariableProfileAssociation (VAR_ProfilZones, $zoneCount, $zoneName, '',-1);	
		if($ZoneId)IPS_SetName($ZoneId, $zoneName);
		if($zonePlayerLink)IPS_SetName($zonePlayerLink,$zoneName);
		$ZoneInfo[$zoneCount]['Name']=$zoneName;
		$zoneCount++;
	}	
	@IPS_SetVariableCustomProfile(VAR_WebFrontZoneSelectorVarId,VAR_ProfilZones);
	foreach($Show_Players as $id=>$state)IPS_SetHidden($id,(($state)?false:true));
	foreach($Show_Instances as $id=>$state)IPS_SetHidden($id,(($state)?false:true));
	foreach($Show_Zones as $id=>$state)IPS_SetHidden($id,(($state)?false:true));
	$i=$z=$p='';
	foreach($ZoneInfo as $id=>$zone){
		$z.="\$SonosZoneInfo[$id]=array('id'=>{$zone['ZoneId']},'master'=>{$zone['MasterPlayer']},'name'=>'{$zone['Name']}');\n";
		$i.="\$SonosZoneIndex[{$zone['ZoneId']}]={$zone['ZoneId']};\n";
	}
	foreach($PlayerInfo as $id=>$player)$p.="\$SonosDeviceInfo[$id]=array('id'=>{$player['ObjectId']},'master'=>{$player['Master']},'zoneid'=>{$player['ZoneId']},'zonenr'=>{$player['ZoneNr']},'ident'=>'{$player['Ident']}');\n";
	$content="<?\n$z$i$p\n?>";
	file_put_contents(IPS_GetKernelDir().'scripts\sonos\sonos.ips.zonecfg.inc',$content);
}	
	
	
function IPSSonos_CreatePlayer($playerData, $position=0){
global 	$TranslationVarProfiles;
		$name=$playerData['name'];
		$ident=$playerData['ident'];
		$PlayerId=@IPS_GetObjectIDByIdent($ident,VAR_PlayerCategoryId);
		if(!$PlayerId){
			$PlayerId = @CreateDummyInstance($ident, VAR_PlayerCategoryId, $position);
			IPS_SetName($PlayerId,$name);
				// Player Variablen erstellen
			IPSSonos_CreateVariable ('SID',3, $PlayerId, 999, '',null, '', '');
			IPSSonos_CreateVariable ('HOST',3, $PlayerId, 998, '',null, $playerData['host'], '');
			foreach ($TranslationVarProfiles as $VarIdent=>$profil){
				if(isSet($profil['HIDDEN']))continue;
				$VarType=(isSet($profil['TYP']))?$profil['TYP']:3;
				$VarProfil=(isSet($profil['PROFIL']))?$profil['PROFIL']:'';
				$VarName=(isSet($profil['NAME']))?$profil['NAME']:$VarIdent;
				IPS_SetName(@IPSSonos_CreateVariable($VarIdent,$VarType,$PlayerId,0,$VarProfil,($VarProfil)?VAR_ActionScriptId:null),$VarName);
			}
			IPSSonos_CreateScriptFromString('Register Events',$PlayerId,'events_reg',"<?\ninclude('sonos\sonos.ips.commands.php');\nIPSSonos_RegisterEvents($PlayerId);\n?>",998);
			IPSSonos_CreateScriptFromString('UnRegister Events',$PlayerId,'events_unreg',"<?\ninclude('sonos\sonos.ips.commands.php');\nIPSSonos_UnRegisterEvents($PlayerId);\n?>",999);
		}else IPS_SetPosition($PlayerId,$position);
		return $PlayerId;
}
function IPSSonos_CreateCategory ($Name, $ParentId, $Position, $Icon=null) {
		$CategoryId = @IPS_GetObjectIDByIdent(IPSSonos_IdentByName($Name), $ParentId);
		if ($CategoryId === false) $CategoryId = @IPS_GetCategoryIDByName($Name, $ParentId);
		if ($CategoryId === false) {
			$CategoryId = IPS_CreateCategory();
			IPS_SetParent($CategoryId, $ParentId);
			IPS_SetName($CategoryId, $Name);
			IPS_SetIdent($CategoryId, $Name);
			if ($Position!==false)IPS_SetPosition($CategoryId, $Position);
			if ($Icon!==false)IPS_SetIcon($CategoryId, $Icon);
			Debug ('Created Category '.$Name.'='.$CategoryId."");
		}
		IPSSonos_UpdateObjectData($CategoryId, $Position, $Icon);
		return $CategoryId;
}
function IPSSonos_CreateVariable ($Name, $Type, $ParentId, $Position=0, $Profile="", $Action=null, $ValueDefault='', $Icon='') {
		$VariableId = @IPS_GetObjectIDByIdent(IPSSonos_IdentByName($Name), $ParentId);
		if ($VariableId === false) $VariableId = @IPS_GetVariableIDByName($Name, $ParentId);
		if ($VariableId === false) {
 			$VariableId = IPS_CreateVariable($Type);
			IPS_SetParent($VariableId, $ParentId);
			IPS_SetName($VariableId, $Name);
			IPS_SetIdent($VariableId, Get_IdentByName($Name));
			IPS_SetPosition($VariableId, $Position);
  			IPS_SetVariableCustomProfile($VariableId, $Profile);
 			IPS_SetVariableCustomAction($VariableId, $Action);
			IPS_SetIcon($VariableId, $Icon);
			if ($ValueDefault===null) {
			   switch($Type) {
			      case 0: SetValue($VariableId, false); break; /*Boolean*/
			      case 1: SetValue($VariableId, 0); break; /*Integer*/
			      case 2: SetValue($VariableId, 0.0); break; /*Float*/
			      case 3: SetValue($VariableId, ""); break; /*String*/
			      default: 
			   }
			} else SetValue($VariableId, $ValueDefault); 
			Debug ('Created VariableId '.$Name.'='.$VariableId."");
		}
		$VariableData = IPS_GetVariable ($VariableId);
		if ($VariableData['VariableCustomProfile'] <> $Profile) {
			Debug ("Set VariableProfile='$Profile' for Variable='$Name' ");
			IPS_SetVariableCustomProfile($VariableId, $Profile);
		}
		if ($VariableData['VariableCustomAction'] <> $Action) {
			Debug ("Set VariableCustomAction='$Action' for Variable='$Name' ");
			IPS_SetVariableCustomAction($VariableId, $Action);
		}
		IPSSonos_UpdateObjectData($VariableId, $Position, $Icon);
		return $VariableId;
}
function IPSSonos_CreateLink ($Name, $Link, $ParentId, $Position, $ident="") {
		$LinkId = false;
		if ($ident<>"") {
			$LinkId = IPS_GetObjectIDByIdent($ident, $ParentId);
		}
		if ($LinkId === false) $LinkId = @IPS_GetLinkIDByName($Name, $ParentId);
		if ($LinkId === false) {
 			$LinkId = IPS_CreateLink();
			IPS_SetParent($LinkId, $ParentId);
			IPS_SetName($LinkId, $Name);
			if ($ident<>"") {
				IPS_SetIdent($LinkId, Get_IdentByName($Name));
			}
			IPS_SetLinkTargetID($LinkId, $Link);
			IPS_SetPosition($LinkId, $Position);
			Debug ('Created Link '.$Name.'='.$LinkId."");
		}
		IPSSonos_UpdateObjectData($LinkId, $Position);
		IPS_SetLinkTargetID($LinkId, $Link);
		return $LinkId;
}
function IPSSonos_CreateScript ($Name, $File, $ParentId, $Position=0) {
		$ScriptId = @IPS_GetObjectIDByIdent(IPSSonos_IdentByName($Name), $ParentId);
		if ($ScriptId === false) $ScriptId = @IPS_GetScriptIDByName($Name, $ParentId);
		if ($ScriptId === false) {
			$File = str_replace(IPS_GetKernelDir().'scripts/', '', $File);
			if (!file_exists(IPS_GetKernelDir().'scripts/'.$File)) {
				Error ("Script File $File could NOT be found !!!");
			}
			$ScriptId = IPS_CreateScript(0);
			IPS_SetParent($ScriptId, $ParentId);
			IPS_SetName($ScriptId, $Name);
			IPS_SetPosition($ScriptId, $Position);
 			IPS_SetScriptFile($ScriptId, $File);
			$oldScriptFile=IPS_GetKernelDir().'scripts/'.$ScriptId.'.ips.php';
			if (file_exists($oldScriptFile)) {
				unlink($oldScriptFile);
			}
			IPS_SetIdent($ScriptId, IPSSonos_IdentByName($Name));
			Debug ('Created Script '.$Name.'='.$ScriptId."");
		}
		IPSSonos_UpdateObjectData($ScriptId, $Position);
		return $ScriptId;
}
function IPSSonos_CreateRegisterVariable($Name, $ParentId, $ScriptId, $PortId, $Position=0) {
		$InstanceId = IPSSonos_CreateInstance($Name, $ParentId, "{F3855B3C-7CD6-47CA-97AB-E66D346C037F}",$Position);
		RegVar_SetRXObjectID($InstanceId, $ScriptId);
		IPS_ConnectInstance($InstanceId, $PortId);
		IPS_ApplyChanges($InstanceId);
		return $InstanceId;
}
function IPSSonos_CreateInstance ($Name, $ParentId, $ModulId, $Position=0) {
		$InstanceId = @IPS_GetObjectIDByIdent($Name, $ParentId);
		if ($InstanceId === false) $InstanceId = @IPS_GetInstanceIDByName($Name, $ParentId);
		if ($InstanceId === false) {
			$InstanceId	= IPS_CreateInstance($ModulId);
			IPS_SetParent($InstanceId, $ParentId);
			IPS_SetName($InstanceId, $Name);
			IPS_SetIdent($InstanceId, Get_IdentByName($Name));
			IPS_SetPosition($InstanceId, $Position);
			Debug ("Created Instance $Name=$InstanceId, ModuleID=$ModulId");
		}
		IPSSonos_UpdateObjectData($InstanceId, $Position);
		return $InstanceId;
}
function IPSSonos_CreateDummyInstance ($Name, $ParentId, $Position=0) {
		return IPSSonos_CreateInstance ($Name, $ParentId, "{485D0419-BE97-4548-AA9C-C083EB82E61E}", $Position);
}
function IPSSonos_IdentByName($name) {
		$ident = str_replace(' ', '', $name);
		$ident = str_replace(array('','','','','',''), array('oe', 'ae','ue','Oe', 'Ae','Ue' ), $ident);
		$ident = str_replace(array('"','\'','%','&','(',')','=','#','<','>','|','\\'), '', $ident);
		$ident = str_replace(array(',','.',':',';','!','?'), '', $ident);
		$ident = str_replace(array('+','-','/','*'), '', $ident);
		$ident = str_replace(array(''), 'ss', $ident);
		return $ident;
}
function IPSSonos_UpdateObjectData($ObjectId, $Position, $Icon="") {
		$ObjectData = IPS_GetObject ($ObjectId);
		$ObjectPath = IPS_GetLocation($ObjectId);
		if ($ObjectData['ObjectPosition'] <> $Position and $Position!==false) {
			Debug ("Set ObjectPosition='$Position' for Object='$ObjectPath' ");
			IPS_SetPosition($ObjectId, $Position);
		}
		if ($ObjectData['ObjectIcon'] <> $Icon and $Icon!==false) {
			Debug ("Set ObjectIcon='$Icon' for Object='$ObjectPath' ");
			IPS_SetIcon($ObjectId, $Icon);
		}
}

function IPSSonos_CreateScriptFromString($Name,$ParentId, $Ident , $Content, $Position=0){
	$sc=IPS_CreateScript(0);IPS_SetParent($sc,$ParentId);IPS_SetIdent($sc,$Ident);IPS_SetName($sc,$Name);IPS_SetScriptContent($sc,$Content);IPS_SetPosition($sc,$Position);
}

?>