<?
include_once('sonos.ips.config.inc');
include_once('sonos.ips.translations.php');

if(!function_exists('Debug')){function Debug($data){if($_IPS['SENDER']=='Execute')echo $data.PHP_EOL;else IPS_LogMessage('SONOS_LOG:',$data);}}
class UpnpEventParser {
	private $VAL=null;
	private $IDX=null;
	private $encodeIn='UTF-8';
	private $encodeOut='ISO-8859-1';
	protected $SID='';
	protected $NAMEDVALS=null;
	public  $DebugFilePrefix='';

	public function SetEncoding($encodeIn, $encodeOut){
		$this->encodeIn=$encodeIn;
		$this->encodeOut=$encodeOut;
	}
	public function SetDebugLocation($location=''){
		$this->$DebugFilePrefix=$location;
	}
	public function Check($content, $callback=null){
		$xml='';
		$this->NAMEDVALS=[];
		if(!$this->SID=$this->_CheckEventFinishd($content,$xml))return false;
		if($this->DebugFilePrefix){
			$date=date('Hms');
			file_put_contents($this->DebugFilePrefix.$date.'_event.txt',html_entity_decode(htmlspecialchars_decode($content)));
		}
		$PARSER=xml_parser_create($this->encodeIn);
		xml_parser_set_option($PARSER, XML_OPTION_TARGET_ENCODING,$this->encodeOut);
		xml_parse_into_struct($PARSER, html_entity_decode(htmlspecialchars_decode($xml)), $this->VAL, $this->IDX);
		xml_parser_free($PARSER);
		foreach($this->IDX as $id=>$i){
			if(isSet($this->VAL[$i[0]]['attributes'])&&isSet($this->VAL[$i[0]]['attributes']['VAL'])){
				$v=$this->VAL[$i[0]]['attributes']['VAL'];
				if(is_float($v))$v=(float)$v;
				elseif(is_numeric($v))$v=(int)$v;
				elseif(is_string($v)){
					if($v=='true'||$v=='ja'||$v=='yes'||$v=='on')$v=true;
					elseif($v=='false'||$v=='nein'||$v=='no'||$v=='off')$v=false;
				}
				$this->NAMEDVALS[$id]=$v;
			}
		}
		if($callback){
			$callback($this->SID,$this->NAMEDVALS);
		};
		return true;
	}	
	function GetValue($name, $typ='attributes',$sub='VAL'){
		if(!isSet($this->IDX[$name]))return false;
		$ip=&$this->VAL[$this->IDX[$name][0]];
		if(!$typ)return $ip;
		if(!isSet($ip[$typ]))return false;
		$vp=&$ip[$typ];
		if(!$sub)return $vp;
		if(!isSet($vp[$sub]))return false;
		return $vp[$sub];
	}
	function GetNamedValues(){
		return $this->NAMEDVALS;
	}
	function & GetValues(){
		return $this->VAL;
	}
	function & GetIndex(){
		return $this->IDX;
	}

	private function _CheckEventFinishd($data, &$content){
		$ContentLength=-1;$SID='';
		$inHead=true; $content='';
		foreach(explode("\n",$data) as $line){
			if($inHead){
				$line=trim($line);
				if(!$line){ $inHead=false; continue; }
				if($ContentLength==-1||!$SID){
					$m=explode(':',$line);
					if($m[0]=='CONTENT-LENGTH'){
						$ContentLength=(int)$m[1];		
					}elseif($m[0]=='SID'){
						array_shift($m);
						$SID=trim(implode(':',$m));
					}
				}
			}else $content.=$line;
		}
		return (($ContentLength!=-1)&& (strlen($content)>=$ContentLength))?$SID:false;
	}
}

class IPSSonosSplitterInstance extends UpnpEventParser {
	private $INSTANCE_ID=0;
	private $CLIENTS_ID=0;
	private $AUTOCREATE=false; // Neue Devices und Variablen Anlegen
	private $CLIENTS=[];
	
	public function __construct($InstanzID){
		$this->InstanzID=$InstanzID;
		$this->CLIENTS_ID=@IPS_GetObjectIdByIdent('CLIENTS',$this->InstanzID);
		if(!$this->CLIENTS_ID){
			$this->CLIENTS_ID=$this->_CreateVariable('CLIENTS',3,$this->InstanzID);
			$this->_CreateVariable('AUTOCREATE',0,$this->InstanzID,false);
			$this->_CreateVariable('AUTOCREATECATID',1,$this->InstanzID,ISP_GetParent($this->InstanzID));
			$this->AUTOCREATE=false;
			$this->CLIENTS=[];
			SetValue($this->CLIENTS_ID,serialize($this->CLIENTS));
		}else {
			if(!$this->CLIENTS=unserialize(GetValue($this->CLIENTS_ID)))$this->CLIENTS=[];
			$this->AUTOCREATE=GetValue(IPS_GetObjectIdByIdent('AUTOCREATE',$this->InstanzID));
		}
	}
	public function HandleEvent($eventData){
		$compled=$this->Check($eventData);
		if($compled){
			if(isSet($this->CLIENTS[$this->SID])){
				$DeviceId=$this->CLIENTS[$this->SID];
			}elseif($this->AUTOCREATE){
				$DeviceId=$this->_CreateDevice($this->SID);
				$this->AddClient($DeviceId,$this->SID);
			}else return false;	

		
			foreach($this->NAMEDVALS as $VarIdent=>$Value){
				$VarValue=IPSSonos_TranslateValue( $VarIdent, $Value);
				if(is_array($VarValue)){
					foreach($VarValue as $SubIdent=>$SubValue){
						if(IPSSonos_TranslateIsHidden($SubIdent)===true)continue;
						$SubName=IPSSonos_TranslateName($SubIdent);
						$SubType=IPSSonos_TranslateType($SubIdent);
						$this->_CreateVariable($SubIdent, $SubType, $DeviceId ,$SubValue, $SubName );
					}
				}else{
					if(IPSSonos_TranslateIsHidden($VarIdent)===true)continue;
					$VarType=IPSSonos_TranslateType($VarIdent);	
					$VarName=IPSSonos_TranslateName( $VarIdent);
					
					$this->_CreateVariable($VarIdent,$VarType, $DeviceId,$VarValue, $VarName );
				}
			}
		}
		return $compled;
	}
	public function AddClient($PlayerInstanceID, $SID){
		$this->CLIENTS[$SID]=$PlayerInstanceID;
		SetValue($this->CLIENTS_ID,serialize($this->CLIENTS));
	}
	public function RemoveClient($PlayerInstanceID, $SID=''){
		$clients=[];
		foreach($this->CLIENTS as $v=>$i){
			if($i!=$PlayerInstanceID)$clients[$v]=$i;
		}
		$this->CLIENTS=$clients;
		SetValue($this->CLIENTS_ID,serialize($this->CLIENTS));
	}
	private function _CreateDevice($SID){
		$deviceCatId=GetValue(IPS_GetObjectIDByIdent('AUTOCREATECATID',$this->INSTANCE_ID));
		if(!$deviceCatId){
			Debug("Keine Kategirie fr neue Gerte konfiguriert");
			return false;
		}		
		preg_match('/RINCON_(.+)_/',$SID,$matches);
		$ident=(isSet($matches[1]))?$matches[1]:$SID;
		
		return $this->_CreateInstance($ident, $deviceCatId);
	}
	private function _CreateVariable ($Ident, $Type,  $ParentId, $Value=null, $Name='') {
		$VariableId = @IPS_GetObjectIDByIdent($Ident, $ParentId);
		if ($VariableId === false) {
			if($Type<0){
				if(is_null($Value)){
					$Type=3;
				}else{
					switch(gettype($Value)){
						case 'boolean': $Type=0;break;
						case 'integer': $Type=1;break;
						case 'float'  : $Type=2;break;
						default       : $Type=3;break;
					}
				}
			}
			$VariableId = IPS_CreateVariable($Type);
			IPS_SetParent($VariableId,$ParentId);
			IPS_SetName($VariableId, (($Name)?$Name:$Ident));
			IPS_SetIdent($VariableId, $Ident);
		}
//Debug("_CreateVar : $Ident ($VariableId)=$Value");				
		if(!is_null($Value)){
			$oldValue=GetValue($VariableId);
			SetValue($VariableId, $Value); 
//Debug("Set Var : $Ident ($VariableId )= Old => $oldValue | New => $Value");				
		}
		return $VariableId;
	}
	private function _CreateInstance($Name, $ParentId, $Position=false) {
		$InstanceId = @IPS_GetObjectIDByIdent(Get_IdentByName($Name), $ParentId);
		if ($InstanceId === false) $InstanceId = @IPS_GetCategoryIDByName($Name, $ParentId);
		if ($InstanceId === false) {
			$InstanceId	= IPS_CreateInstance("{485D0419-BE97-4548-AA9C-C083EB82E61E}");
			IPS_SetParent($InstanceId, $ParentId);
			IPS_SetName($InstanceId, $Name);
			IPS_SetIdent($InstanceId, $Name);
			if ($Position!==false)IPS_SetPosition($InstanceId, $Position);
			$this->_CreateVariable('SID',3,$InstanceId);
			$this->_CreateVariable('HOST',3,$InstanceId);
			//IPS_SetIcon($CategoryId, $Icon);
//			Debug ('Created Category '.$Name.'='.$CategoryId."");
		}
		return $InstanceId;
	}
}

function IPSSonos_SplitterAddClient($DeviceID, $SID){
	if(!defined('VAR_SplitterInstanceId')){
		Debug ('IPSSonos_SplitterRemoveClient:: Keine SplitterInstanceId in sonoa.ips.config.inc definiert!!!! Lsung:ReInstall');
		return false;
	}
	return (new IPSSonosSplitterInstance(VAR_SplitterInstanceId))->AddClient($DeviceID,$SID);
}
function IPSSonos_SplitterRemoveClient($DeviceID){
	if(!defined('VAR_SplitterInstanceId')){
		Debug ('IPSSonos_SplitterRemoveClient:: Keine SplitterInstanceId in sonoa.ips.config.inc definiert!!!! Lsung:ReInstall');
		return false;
	}
	return (new IPSSonosSplitterInstance(VAR_SplitterInstanceId))->RemoveClient($DeviceID);
}

?>